package com.tanpu.community.dao.mapper.community;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.tanpu.community.dao.entity.community.ThemeEntity;
import com.tanpu.community.dao.entity.community.TimesCountEntity;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import java.time.LocalDateTime;
import java.util.Collection;
import java.util.List;

/**
 * <p>
 * 主题内容 Mapper 接口
 * </p>
 *
 * @author xudong
 * @since 2022-02-21
 */
public interface ThemeMapper extends BaseMapper<ThemeEntity> {

    @Select("select former_theme_id as id, count(1) as times from theme ${ew.customSqlSegment}")
    List<TimesCountEntity> selectCountByThemeIds(@Param(Constants.WRAPPER) LambdaQueryWrapper wrapper);

    ThemeEntity queryOneByTopicIdOrderByUpdateTimeDesc(@Param("topicId") String topicId);

    Integer countByTopicIdAndCreateTimeAfter(@Param("topicId") String topicId, @Param("minCreateTime") LocalDateTime minCreateTime);

    List<ThemeEntity> queryRecentdaysOrHasTopic(@Param("deleteTag") Integer deleteTag, @Param("minCreateTime") LocalDateTime minCreateTime, @Param("notTopicId") String notTopicId);


    /**
     * 关注人+关注话题下的帖子，带分页
     *
     * @param followUsers
     * @param followTopics
     * @return
     */
    List<ThemeEntity> queryFollowList(@Param("authorIdCollection") Collection<String> followUsers, @Param("topicIdCollection") Collection<String> followTopics,
                                      @Param("pageStart") Integer pageStart, @Param("pageSize") Integer pageSize);


}
